﻿using System;
using Android.App;
using Android.Content;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.OS;
using Com.Cipherlab.Barcode;
using Com.Cipherlab.Barcode.Decoderparams;
using Com.Cipherlab.Barcode.Decoder;

namespace XamarinExample
{
    [Activity(Label = "XamarinExample", MainLauncher = true, Icon = "@drawable/icon")]
    public class MainActivity : Activity
    {
        //int count = 1;

        static ReaderManager m_RM = null;
        static TextView Scan_Data;
        static EditText HW_Scan_Data;
        static String sDataStr = "";
        private IntentFilter filter;
        private DataReceiver myDataReceiver;
        static Spinner spinner;
        int Beep_item = -1;

        protected override void OnCreate(Bundle bundle)
        {
            base.OnCreate(bundle);

            // Reader InitInstance
            m_RM = ReaderManager.InitInstance(this);
            myDataReceiver = new DataReceiver();

            filter = new IntentFilter();
            filter.AddAction(GeneralString.IntentREADERSERVICECONNECTED);
            filter.AddAction(GeneralString.IntentSOFTTRIGGERDATA);
            filter.AddAction(GeneralString.IntentPASSTOAPP);
            RegisterReceiver(myDataReceiver, filter);

            // Set our view from the "main" layout resource
            SetContentView(Resource.Layout.Main);

            // Get our button from the layout resource,
            // and attach an event to it
            Button button = FindViewById<Button>(Resource.Id.MyButton);
            button.Click += delegate 
            {
                //button.Text = string.Format("{0} clicks!", count++);
                NotificationParams settings_NotificationParams = new NotificationParams();
                m_RM.Get_NotificationParams(settings_NotificationParams);
                if (Beep_item == 0)
                    settings_NotificationParams.ReaderBeep = BeepType.Mute;
                else if (Beep_item == 1)
                    settings_NotificationParams.ReaderBeep = BeepType.Default;
                else if (Beep_item == 2)
                    settings_NotificationParams.ReaderBeep = BeepType.Hwandsw;
                else if (Beep_item == 3)
                    settings_NotificationParams.ReaderBeep = BeepType.MenuPop;
                else if (Beep_item == 4)
                    settings_NotificationParams.ReaderBeep = BeepType.MsgBox;
                else if (Beep_item == 5)
                    settings_NotificationParams.ReaderBeep = BeepType.Notify;
                else if (Beep_item == 6)
                    settings_NotificationParams.ReaderBeep = BeepType.VoicBeep;
                else if (Beep_item == 7)
                    settings_NotificationParams.ReaderBeep = BeepType.Alarm2;
                else if (Beep_item == 8)
                    settings_NotificationParams.ReaderBeep = BeepType.Alarm3;
                else if (Beep_item == 9)
                    settings_NotificationParams.ReaderBeep = BeepType.LowBatt;

                if (ClResult.SErr == m_RM.Set_NotificationParams(settings_NotificationParams))
                    Toast.MakeText(this, "Set_NotificationParams was failed", ToastLength.Short).Show();
                else
                    Toast.MakeText(this, "Set_NotificationParams was successful", ToastLength.Short).Show();
            };

            Button button_scan = FindViewById<Button>(Resource.Id.button1);
            button_scan.Click += delegate {
                m_RM.SoftScanTrigger();
            };

            Scan_Data = FindViewById<TextView>(Resource.Id.textView1);

            spinner = this.FindViewById<Spinner>(Resource.Id.spinner1);
            var adapter = ArrayAdapter.CreateFromResource(
                this, Resource.Array.planets_array, Android.Resource.Layout.SimpleSpinnerItem);

            adapter.SetDropDownViewResource(Android.Resource.Layout.SimpleSpinnerDropDownItem);
            spinner.Adapter = adapter;

            spinner.ItemSelected += (sender, e) =>
            {
                var s = sender as Spinner;
                Beep_item = e.Position;
                //Toast.MakeText(this, "My Bepper is " + s.GetItemAtPosition(e.Position), ToastLength.Short).Show();
            };

            HW_Scan_Data = FindViewById<EditText>(Resource.Id.editText1);

            Button button_hw_func = FindViewById<Button>(Resource.Id.button2);
            button_hw_func.Click += delegate
            {
                Intent ifunc = new Intent("android.intent.action.FUNC_BUTTON");
                SendBroadcast(ifunc);
            };

            Button button_hw_func_release = FindViewById<Button>(Resource.Id.button3);
            button_hw_func_release.Click += delegate {
                Intent ifuncrelease = new Intent("android.intent.action.FUNC_RELEASE_BUTTON");
                SendBroadcast(ifuncrelease);
            };
        }

        protected override void OnDestroy()
        {
            base.OnDestroy();

            // ***************************************************//
            // 在關閉此APP前可以先註銷之前的Broadcast Receiver
            // ***************************************************//
            UnregisterReceiver(myDataReceiver);

            // Reader Release
            m_RM.Release();
        }

        /// 產生一個broadcast 物件，用來接收service丟過來的intent
		class DataReceiver : BroadcastReceiver
        {
            public override void OnReceive(Context context, Android.Content.Intent intent)
            {
                // 如果收到Intent_SOFTTRIGGER_DATA這個字串的intent的話
                if (intent.Action == GeneralString.IntentSOFTTRIGGERDATA)
                {
                    sDataStr = "";
                    // 把intent裡夾帶的資料取出來
                    sDataStr = intent.GetStringExtra(GeneralString.BcReaderData);

                    Toast.MakeText(context, sDataStr, ToastLength.Short).Show();
                    Scan_Data.Text = sDataStr;
                }
                else if (intent.Action == GeneralString.IntentREADERSERVICECONNECTED)
                {
                    NotificationParams gettings_NotificationParams = new NotificationParams();
                    m_RM.Get_NotificationParams(gettings_NotificationParams);
                    if (gettings_NotificationParams.ReaderBeep == BeepType.Mute)
                        spinner.SetSelection(0);
                    else if (gettings_NotificationParams.ReaderBeep == BeepType.Default)
                        spinner.SetSelection(1);
                    else if (gettings_NotificationParams.ReaderBeep == BeepType.Hwandsw)
                        spinner.SetSelection(2);
                    else if (gettings_NotificationParams.ReaderBeep == BeepType.MenuPop)
                        spinner.SetSelection(3);
                    else if (gettings_NotificationParams.ReaderBeep == BeepType.MsgBox)
                        spinner.SetSelection(4);
                    else if (gettings_NotificationParams.ReaderBeep == BeepType.Notify)
                        spinner.SetSelection(5);
                    else if (gettings_NotificationParams.ReaderBeep == BeepType.VoicBeep)
                        spinner.SetSelection(6);
                    else if (gettings_NotificationParams.ReaderBeep == BeepType.Alarm2)
                        spinner.SetSelection(7);
                    else if (gettings_NotificationParams.ReaderBeep == BeepType.Alarm3)
                        spinner.SetSelection(8);
                    else if (gettings_NotificationParams.ReaderBeep == BeepType.LowBatt)
                        spinner.SetSelection(9);

                    ReaderOutputConfiguration gettings_OutputConfiguration = new ReaderOutputConfiguration();
                    m_RM.Get_ReaderOutputConfiguration(gettings_OutputConfiguration);

                    gettings_OutputConfiguration.EnableKeyboardEmulation = KeyboardEmulationType.None;  // None is Intent

                    m_RM.Set_ReaderOutputConfiguration(gettings_OutputConfiguration);
                }
                else if (intent.Action == GeneralString.IntentPASSTOAPP)
                {
                    sDataStr = "";
                    // 把intent裡夾帶的資料取出來
                    sDataStr = intent.GetStringExtra(GeneralString.BcReaderData);

                    Toast.MakeText(context, sDataStr, ToastLength.Short).Show();
                    HW_Scan_Data.Text = sDataStr;
                }
            }
        }
    }
}

